//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#pragma inline
DWORD __fastcall GetCrc32(char *_ptr, int _bSize);
#include "Crc.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;

//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ModeRadioGroupClick(TObject *Sender)
{
	if (ModeRadioGroup->ItemIndex == 0) {
   	BrowseButton->Enabled = false;
      Label1->Caption = "String :";
   } else {
   	BrowseButton->Enabled = true;
      Label1->Caption = "File :";
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ExitButtonClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CalculateButtonClick(TObject *Sender)
{
	DWORD Crc32;
	if (ModeRadioGroup->ItemIndex == 0) {
   	if (!StringEdit->Text.Length())
      	CrcEdit->Text = "";
      else {
   		Crc32 = GetCrc32(StringEdit->Text.c_str(),
      			StringEdit->Text.Length());
      	CrcEdit->Text = AnsiString::IntToHex(Crc32, 8);
   	}
   } else {
   	HFILE hf = _lopen(StringEdit->Text.c_str(), OF_READ);
		if (hf == HFILE_ERROR) {
      	ShowMessage("File system error.");
         CrcEdit->Text = "";
         return;
      }
      int fSize = GetFileSize((void *)hf, NULL);
      if (!fSize) {
      	ShowMessage("File is empty.");
         CrcEdit->Text = "";
         return;
      }
      char *buff = (char *)GlobalAlloc(GMEM_FIXED, fSize);
		if (_lread(hf, buff, fSize)!=fSize) {
         ShowMessage("File system error.");
         CrcEdit->Text = "";
         return;
      }
      Crc32 = GetCrc32(buff, fSize);
      CrcEdit->Text = AnsiString::IntToHex(Crc32, 8);
   }
   StringEdit->SetFocus();
}
//---------------------------------------------------------------------------
DWORD __fastcall GetCrc32(char *_ptr, int _bSize)
{
	DWORD result;
   if (!_bSize) return 0;
	__asm {
		mov esi, _ptr
   	mov edi, _bSize
   	cld
	xor edx, edx
	dec edx

_nextByteCRC:
	xor eax, eax
	lodsb
	xor al, dl
	xor ecx, ecx
	mov cl, 8
	shr edx, cl

_nextBitCRC:
	clc
	rcr eax, 1
	jnc _noCRC
	xor eax, 0EDB88320h

_noCRC:
	loop _nextBitCRC
	xor edx, eax
	dec edi
	jnz _nextByteCRC
	mov eax, edx
	not eax
      mov result, eax
 	}
   return result;
}
void __fastcall TMainForm::StringEditKeyPress(TObject *Sender, char &Key)
{
	if (Key == 13)
   	TMainForm::CalculateButtonClick(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::BrowseButtonClick(TObject *Sender)
{
	if (OpenDialog->Execute()) {
   	StringEdit->Text = OpenDialog->FileName;
      CrcEdit->Text = "";
   }
}
//---------------------------------------------------------------------------

